/*  Note: You are free to use whatever license you want.
    Eventually you will be able to edit it within Glade. */

/*  ghost-edit
 *  Copyright (C) <YEAR> <AUTHORS>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <string.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <unistd.h>
#include "ghost-edit.h"
#include "ghost-edit-sig.h"

gchar *hostTableFile = "/etc/hosts";
gchar *enableUpdate;
gint currentRow;

GtkWidget *filePicker, *saveCompletedBox, *fileErrorBox;
GtkWidget *window, *hosttable, *ip, *hostname, *alias, *btnAdd, *btnEdit;
gchar *l_Hostname;
gchar *l_IP;
gchar *l_Aliases;
gchar *field[100][3];
gboolean updateFlag = FALSE;
gboolean readFromFile = FALSE;
 
int
main (int argc, char *argv[])
{
  GtkWidget *main;

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  main = create_main ();
  set_StatusBar("Welcome to gHost-Edit!");

  gtk_widget_show (main);
  filePicker = create_fileselection1 ();
  saveCompletedBox = create_saveComplete ();
  fileErrorBox = create_fileError ();

  swap_Update_Enable(FALSE);

  parse_cl_switches(argc, argv);

  gtk_main ();
  return 0;
}

void
set_StatusBar                          (gchar *text)
{

/*  gtk_statusbar_pop(GTK_STATUSBAR(statusbar_main), context_ID);
 *  context_ID = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar_main), text);
 *  gtk_statusbar_push(GTK_STATUSBAR(statusbar_main), context_ID, text);
 */
}

gboolean
read_Host_File                         (gpointer user_data)
{
  FILE *hosts;
  gchar buf[100];
  gint i, y;
  gint c = 1;
  gboolean retVal = TRUE;

  if(readFromFile == TRUE){
    hostTableFile = gtk_file_selection_get_filename(user_data); 
  }

  hosts = fopen(hostTableFile, "r");

  if(hosts != NULL){
    for(i = 0; i < 100; i++) 
    { 
      for(y = 0; y < 3; y++)
      {
        c = fscanf(hosts, "%s", buf);
        if(c != EOF){
          field[i][y] = g_strdup(buf);
        }else{
          field[i][y] = NULL;
        }
      }
    }
  }else{
    retVal = FALSE;
    gtk_widget_show(fileErrorBox);
  }

  fclose(hosts);

  updateFlag = TRUE;  

  return retVal;
}


void
parse_cl_switches                      (gint argc, gchar *argv[])
{
  int i;

  for(i = 1; i < argc; i++)
    {
      if(argv[i])
	{
          hostTableFile = argv[i];
	  read_Host_File(NULL);
	}
    }
}

void
populate_Host_Entries                  (gpointer user_data)
{
  gint i;

  if(updateFlag == TRUE)
    {
      window = gtk_widget_get_toplevel (user_data);
      hosttable = gtk_object_get_data (GTK_OBJECT(window), "clist_HostTable");

      gtk_clist_clear(GTK_CLIST(hosttable));
      gtk_window_set_title (GTK_WINDOW(window), hostTableFile);

      for(i = 0; i < 100; i++)
        {
	  if(field[i][0] != NULL)
	    {
              gchar *entryText[1][3] = {{ field[i][0], field[i][1], field[i][2] }};
              gtk_clist_append(GTK_CLIST(hosttable), entryText[0] );
	    }
        }
      updateFlag = FALSE;
    }
}

void
swap_Update_Enable                     (gchar *c)

{
  if (c != "T")
    enableUpdate = "F";
  else
  {
    enableUpdate = "T";
  }
}

void
set_Current_Row                        (gint row)

{
  currentRow = row;
}

gint
get_Current_Row                        ()

{
  gint activeRow;

  activeRow = currentRow;

  return activeRow;
}

void
on_File_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_Host_Table_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  readFromFile = TRUE;

  gtk_widget_show(filePicker);
}


void
on_Help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_btn_Add_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 

  window = gtk_widget_get_toplevel (user_data);
  hosttable = gtk_object_get_data (GTK_OBJECT(window), "clist_HostTable");
  ip = gtk_object_get_data (GTK_OBJECT(window), "entry_IP");
  hostname = gtk_object_get_data (GTK_OBJECT(window), "entry_Hostname");
  alias = gtk_object_get_data (GTK_OBJECT(window), "entry_Aliases");
  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");

  l_IP = gtk_entry_get_text(GTK_ENTRY(ip));
  l_Hostname = gtk_entry_get_text(GTK_ENTRY(hostname));
  l_Aliases = gtk_entry_get_text(GTK_ENTRY(alias));

  gtk_entry_set_text(GTK_ENTRY(ip), "");
  gtk_entry_set_text(GTK_ENTRY(hostname), "");
  gtk_entry_set_text(GTK_ENTRY(alias), "");

  
  if ( l_IP != NULL )
    {
     gchar *entryText[1][3] = {{ l_IP, l_Hostname, l_Aliases }};
     gtk_clist_append(GTK_CLIST(hosttable), entryText[0] );
    }
 

  gtk_widget_set_sensitive(GTK_WIDGET(btnAdd), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(btnEdit), FALSE);


  return;
}

void
on_btn_Edit_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

  gint activeRow;

  window = gtk_widget_get_toplevel (user_data);
  hosttable = gtk_object_get_data (GTK_OBJECT(window), "clist_HostTable");
  ip = gtk_object_get_data (GTK_OBJECT(window), "entry_IP");
  hostname = gtk_object_get_data (GTK_OBJECT(window), "entry_Hostname");
  alias = gtk_object_get_data (GTK_OBJECT(window), "entry_Aliases");
  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");
  activeRow = get_Current_Row();

  l_IP = gtk_entry_get_text(GTK_ENTRY(ip));
  l_Hostname = gtk_entry_get_text(GTK_ENTRY(hostname));
  l_Aliases = gtk_entry_get_text(GTK_ENTRY(alias));
 
  gtk_entry_set_text(GTK_ENTRY(ip), "");
  gtk_entry_set_text(GTK_ENTRY(hostname), "");
  gtk_entry_set_text(GTK_ENTRY(alias), "");

  gtk_clist_set_text(GTK_CLIST(hosttable), activeRow, 0, l_IP);
  gtk_clist_set_text(GTK_CLIST(hosttable), activeRow, 1, l_Hostname);
  gtk_clist_set_text(GTK_CLIST(hosttable), activeRow, 2, l_Aliases);

  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");
  gtk_widget_set_sensitive (GTK_WIDGET(btnAdd), FALSE );
  gtk_widget_set_sensitive (GTK_WIDGET(btnEdit), FALSE );

  swap_Update_Enable("F");
}


void
on_btn_Close_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_main_quit();
}

void
on_clist_HostTable_select_row          (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gchar *text;

  window = gtk_widget_get_toplevel (user_data);
  hosttable = gtk_object_get_data (GTK_OBJECT(window), "clist_HostTable");
  ip = gtk_object_get_data (GTK_OBJECT(window), "entry_IP");
  hostname = gtk_object_get_data (GTK_OBJECT(window), "entry_Hostname");
  alias = gtk_object_get_data (GTK_OBJECT(window), "entry_Aliases");
  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");

  set_Current_Row(row);

  gtk_clist_get_text (GTK_CLIST(hosttable), row, 0, &text);
  gtk_entry_set_text (GTK_ENTRY(ip), text);
  gtk_clist_get_text (GTK_CLIST(hosttable), row, 1, &text);
  gtk_entry_set_text (GTK_ENTRY(hostname), text);
  gtk_clist_get_text (GTK_CLIST(hosttable), row, 2, &text);
  gtk_entry_set_text (GTK_ENTRY(alias), text);

  gtk_widget_set_sensitive (GTK_WIDGET(btnAdd), FALSE );
  gtk_widget_set_sensitive (GTK_WIDGET(btnEdit), FALSE );

  swap_Update_Enable("T");
}

void
on_entry_IP_insert_text                (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gint            *position,
                                        gpointer         user_data)
{
 

  window = gtk_widget_get_toplevel (user_data);
  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");

  gtk_widget_set_sensitive (GTK_WIDGET(btnAdd), TRUE );

  if (enableUpdate == "T")
    gtk_widget_set_sensitive (GTK_WIDGET(btnEdit), TRUE );

}

void
on_popup_Main_selection_done           (GtkMenuShell    *menushell,
                                        gpointer         user_data)
{

}


void
on_popup_Main_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

void
on_entry_Hostname_insert_text          (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gint            *position,
                                        gpointer         user_data)
{


  window = gtk_widget_get_toplevel (user_data);
  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");

  gtk_widget_set_sensitive (GTK_WIDGET(btnAdd), TRUE );

  if (enableUpdate == "T")
    gtk_widget_set_sensitive (GTK_WIDGET(btnEdit), TRUE );

}


void
on_entry_Aliases_insert_text           (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gint            *position,
                                        gpointer         user_data)
{


  window = gtk_widget_get_toplevel (user_data);
  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");

  gtk_widget_set_sensitive (GTK_WIDGET(btnAdd), TRUE );

  if (enableUpdate == "T")
    gtk_widget_set_sensitive (GTK_WIDGET(btnEdit), TRUE );

}


void
on_text_Comments_insert_text           (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gint            *position,
                                        gpointer         user_data)
{


  window = gtk_widget_get_toplevel (user_data);
  btnAdd = gtk_object_get_data (GTK_OBJECT(window), "btn_Add");
  btnEdit = gtk_object_get_data (GTK_OBJECT(window), "btn_Edit");

  gtk_widget_set_sensitive (GTK_WIDGET(btnAdd), TRUE );

  if (enableUpdate == "T")
    gtk_widget_set_sensitive (GTK_WIDGET(btnEdit), TRUE );

}


void
on_btn_Save_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *savedHostTableFile;
  gchar *ip, *hostname, *aliases;
  gint i;
  FILE *outfile;

  window = gtk_widget_get_toplevel(user_data);
  hosttable = gtk_object_get_data(GTK_OBJECT(window), "clist_HostTable");
  savedHostTableFile = gtk_object_get_data(GTK_OBJECT(saveCompletedBox), "savedHostFile");

  outfile=fopen(hostTableFile, "w");

  if(!outfile)
    outfile=stdout;

  for(i=0; i < GTK_CLIST(hosttable)->rows; i++){
    gtk_clist_get_text(GTK_CLIST(hosttable), i, 0, &ip);
    gtk_clist_get_text(GTK_CLIST(hosttable), i, 1, &hostname);
    gtk_clist_get_text(GTK_CLIST(hosttable), i, 2, &aliases);

    fprintf(outfile, "%s	", ip);
    fprintf(outfile, "%s ", hostname);
    fprintf(outfile, "%s\n", aliases);

    ip = "";
    hostname = "";
    aliases = "";
  }

  if(outfile != stdout)
    fclose(outfile);

  gtk_label_set(GTK_LABEL(savedHostTableFile), hostTableFile);
  gtk_widget_show(saveCompletedBox);
  
  return;
}


void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  gboolean readCorrectly = FALSE;

  readCorrectly = read_Host_File(user_data);
  gtk_widget_hide(user_data);
 
}

void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
}


void
on_savedOK_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);
}




gboolean
on_entry_IP_enter_notify_event         (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
  set_StatusBar(user_data);
  return FALSE;
}


gboolean
on_entry_IP_leave_notify_event         (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
  set_StatusBar(user_data);
  return FALSE;
}











gboolean
on_entry_Hostname_enter_notify_event   (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
  set_StatusBar(user_data);
  return FALSE;
}


gboolean
on_entry_Hostname_leave_notify_event   (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
  set_StatusBar(user_data);
  return FALSE;
}


gboolean
on_entry_Aliases_enter_notify_event    (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
  set_StatusBar(user_data);
  return FALSE;
}


gboolean
on_entry_Aliases_leave_notify_event    (GtkWidget       *widget,
                                        GdkEventCrossing *event,
                                        gpointer         user_data)
{
  set_StatusBar(user_data);
  return FALSE;
}


void
on_btn_Remove_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  window = gtk_widget_get_toplevel (user_data);
  hosttable = gtk_object_get_data (GTK_OBJECT(window), "clist_HostTable");   
  ip = gtk_object_get_data (GTK_OBJECT(window), "entry_IP");
  hostname = gtk_object_get_data (GTK_OBJECT(window), "entry_Hostname");
  alias = gtk_object_get_data (GTK_OBJECT(window), "entry_Aliases");

  gtk_entry_set_text(GTK_ENTRY(ip), "");
  gtk_entry_set_text(GTK_ENTRY(hostname), "");
  gtk_entry_set_text(GTK_ENTRY(alias), "");

  gtk_clist_remove(GTK_CLIST(hosttable), get_Current_Row());

}




void
on_ok_button1_hide                     (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_fileselection1_hide                 (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


GtkDirectionType
on_main_focus                          (GtkContainer    *container,
                                        GtkDirectionType direction,
                                        gpointer         user_data)
{
    return(direction);
}



void
on_main_state_changed                  (GtkWidget       *widget,
                                        GtkStateType     state,
                                        gpointer         user_data)
{

}


gboolean
on_main_focus_in_event                 (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
  populate_Host_Entries(user_data);
  return FALSE;
}




void
on_main_realize                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
  gboolean readCorrectly = FALSE;
  readCorrectly = read_Host_File(user_data);

}


void
on_ok_clicked                          (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(user_data);

}

